/*************************************************************************************
MAT259 Winter22 - 2021 youtube trending videos analysis
 Author: Lijuan Cheng
 Supervisor: George Legrady
 Tool: Processing 4.0b3
 *************************************************************************************/

import peasy.*;
import controlP5.*;

PeasyCam cam;
ControlP5 cp5;

PFont f, f2;
Table table1, table2, table3;
ArrayList<Video> videos1 = new ArrayList<Video>();
ArrayList<Video> videos2 = new ArrayList<Video>();
ArrayList<Video> videos3 = new ArrayList<Video>();
Boolean showCategory_26 = false, showCategory_27 = false, showCategory_28 = true, showRotateX = false,
  showRotateY = false, showRotateZ = false, showResponse = false, showPoint = true, showMove = true,
  showChannel1 = true, showChannel2 = true, showChannel3 = true, changeChannelColor = false;
int buttonWidth = 150;
int buttonHeight = 25;
int buttonSpace = 30;
String[] categories = {"Howto & Style", "Education", "Science & Technology"};
int[] colors = {#eb3493, #eb8634, #34ebbd};
ArrayList<String> channels1 = new ArrayList<String>();
ArrayList<String> channels2 = new ArrayList<String>();
ArrayList<String> channels3 = new ArrayList<String>();

void setup() {
  //size(1200, 800, P3D);
  fullScreen(P3D);
  cam = new PeasyCam(this, 200);
  f = createFont("Arial", 14);

  //Menu control
  cp5 = new ControlP5(this);

  textFont(f);

  for (int i = 0; i< 3; i++) {
    cp5.addButton(categories[i])
      .setPosition(50, 700+i*buttonSpace)
      .setSize(buttonWidth, buttonHeight)
      .setColorBackground(color(colors[i]))
      .setColorForeground(color(#626262))
      .setColorActive(color(colors[i]))
      .setValue(0)
      .setId(i);
    cp5.getController(categories[i]).getCaptionLabel().toUpperCase(false).setFont(f);
  }

  f2 = createFont("Arial", 12);
  cp5.addButton("Change Channel Color").setPosition(50, 400).setSize(buttonWidth + 15, buttonHeight).setColorBackground(color(#1c2fff)).setId(3);
  cp5.getController("Change Channel Color").getCaptionLabel().toUpperCase(false).setFont(f2);
  cp5.setAutoDraw(false);

  table1 = loadTable("2021_26_v2.csv", "header");
  table2 = loadTable("2021_27_v2.csv", "header");
  table3 = loadTable("2021_28_v2.csv", "header");

  videos1 = videosConstruction(table1);
  videos2 = videosConstruction(table2);
  videos3 = videosConstruction(table3);

  channels1 = creat_channels(videos1);
  channels2 = creat_channels(videos2);
  channels3 = creat_channels(videos3);

  for (int i = 0; i < videos1.size(); i++) {
    Video video = videos1.get(i);
    if (video.published_date.startsWith("2020") || video.view_count == 0 || video.response_count <= 5) {
      continue;
    }
    video.pointCoordinate();
  }

  for (int i = 0; i < videos2.size(); i++) {
    Video video = videos2.get(i);
    if (video.published_date.startsWith("2020") || video.view_count == 0 || video.response_count <= 5) {
      continue;
    }
    video.pointCoordinate();
  }

  for (int i = 0; i < videos3.size(); i++) {
    Video video = videos3.get(i);
    if (video.published_date.startsWith("2020") || video.view_count == 0 || video.response_count <= 5) {
      continue;
    }
    video.pointCoordinate();
  }

  smooth(4);
}

void draw() {
  background(0);
  int r1, g1, b1;
  int r2, g2, b2;
  int r3, g3, b3;

  if (showRotateZ == true) rotateZ(frameCount / 100.0);
  if (showRotateY == true) rotateY(frameCount / 100.0);
  if (showRotateX == true) rotateX(frameCount / 100.0);

  if (showCategory_26 == true) {
    drawPoints(videos1);
    stroke(colors[0]); //235, 52, 147
    r1 = 235;
    g1 = 52;
    b1 = 147;

    if (showChannel1 == true) {
      for (int i = 0; i < channels1.size(); i++) {
        String channel = channels1.get(i);
        if (changeChannelColor == true) {
          stroke(r1+2*i, g1+6*i, b1+4*i);
        }
        drawChannelLines(channel, videos1);
      }
    }
    if (showMove == true) {
      for (int i = 0; i < videos1.size(); i++) {
        Video video = videos1.get(i);
        if (video.published_date.startsWith("2020") || video.view_count == 0 || video.response_count <= 5) {
          continue;
        }
        video.update();
        video.show();
      }
    }
  }

  if (showCategory_27 == true) {
    drawPoints(videos2);
    stroke(colors[1]); //235, 134, 52
    r2 = 235;
    g2 = 134;
    b2 = 52;

    if (showChannel2 == true) {
      for (int i = 0; i < channels2.size(); i++) {
        String channel = channels2.get(i);
        if (changeChannelColor == true) {
          stroke(r2+i, g2+2*i, b2+5*i);
        }
        drawChannelLines(channel, videos2);
      }
    }

    if (showMove == true) {
      for (int i = 0; i < videos2.size(); i++) {
        Video video = videos2.get(i);
        if (video.published_date.startsWith("2020") || video.view_count == 0 || video.response_count <= 5) {
          continue;
        }
        video.update();
        video.show();
      }
    }
  }

  if (showCategory_28 == true) {
    drawPoints(videos3);
    stroke(colors[2]); // 52, 235, 189 hsv: 165°, 78%, 92%
    r3 = 52 ;
    g3 = 235;
    b3 = 189;

    if (showChannel3 == true) {
      for (int i = 0; i < channels3.size(); i++) {
        String channel = channels3.get(i);
        if (changeChannelColor == true) {
          stroke(r3 + 5 * i, g3+i, b3+2*i);
        }
        drawChannelLines(channel, videos3);
      }
    }
    if (showMove == true) {
      for (int i = 0; i < videos3.size(); i++) {
        Video video = videos3.get(i);
        if (video.published_date.startsWith("2020") || video.view_count == 0 || video.response_count <= 5) {
          continue;
        }
        video.update();
        video.show();
      }
    }
  }

  pushMatrix();
  translate(0, 0, 0);
  strokeWeight(2);
  //fill(200, 20);
  noFill();
  stroke(#1727d1);
  box(400, 400, 1200);
  popMatrix();
  drawLabels(-600);
  drawLabels(600);

  gui();
}
