class Video {
  String title;
  String channelTitle;
  int categoryId;
  int view_count;
  int response_count;
  String published_date;
  String published_time;
  String trending_date;
  float x, y, z;
  PVector speed, pCoordinate;
  int published_year, published_month, published_day;
  float hour, minute, second;

  Video(String title, String channelTitle, int categoryId, int view_count, int response_count, String published_date, String published_time, String trending_date) {
    this.title = title;
    this.channelTitle = channelTitle;
    this.categoryId = categoryId;
    this.view_count = view_count;
    this.response_count = response_count;
    this.published_date = published_date;
    this.published_time = published_time;
    this.trending_date = trending_date;
  }

  void pointCoordinate() {
    String[] published_dates = split(published_date, '-');
    published_year = int(published_dates[0]);
    published_month = int(published_dates[1]);
    published_day = int(published_dates[2]);

    String[] trending_dates = split(trending_date, '-');
    //int trending_year = int(trending_dates[0]);
    int trending_month = int(trending_dates[1]);
    int trending_day = int(trending_dates[2]);

    String[] times = split(published_time, ':');
    hour = float(times[0]);
    minute = float(times[1]);
    second = float(times[2]);

    x = map(((published_month - 1) * 30 + published_day), 0, 365, -200, 200);
    y = map((hour * 60 + minute + second/60), 0, 1440, -200, 200);
    z = map(log(view_count), log(60000), log(89070000), -600, 600);

    //pCoordinate = new PVector(x, y, z);
    speed = new PVector();
    speed.x = map(((published_month - 1) * 30 + published_day), 0, 365, -2, 2);
    speed.y = map((hour * 60 + minute + second/60), 0, 1440, -2, 2);
    speed.z = map(log(view_count), log(60000), log(89070000), -5, 5);

  }

  void update() {

      x = x + speed.x;
      y = y + speed.y;
      z = z + speed.z;
    

    if (x > 200 || x < -200) {
      speed.x = -speed.x;
    }

    if (y > 200 || y < -200) {
      speed.y = -speed.y;
    }

    if (z > 600 || z < -600) {
      speed.z = -speed.z;
    }
  }

  void show() {
    color c = colorDetermine(categoryId);
    float radius = map(log(response_count), log(1802), log(2404748), 1, 4);
    pushMatrix();
    fill(c);
    noStroke();
    strokeWeight(2);
    translate(x, y, z);
    strokeWeight(2);
    point(0, 0, 0);
    ellipse(0, 0, radius, radius);
    popMatrix();
  }
}  
